ECHO OFF
CLS

IF NOT EXIST "%ProgramW6432%\QGIS 3.16\bin" (
	IF NOT EXIST "%ProgramFiles(x86)%\QGIS 3.16\bin" (
		START CMD /C "ECHO The QGIS installation folder has not been found. && PAUSE"
		GOTO EXITHERE
		) ELSE SET "QGIS_FOLDER=%ProgramFiles(x86)%\QGIS 3.16\bin"
) ELSE SET "QGIS_FOLDER=%ProgramW6432%\QGIS 3.16\bin"

IF NOT EXIST "%QGIS_FOLDER%\python-qgis.bat" (
	IF NOT EXIST "%QGIS_FOLDER%\python-qgis-ltr.bat" (
		START CMD /C "ECHO The QGIS python bat doesn't exist. && PAUSE"
		GOTO EXITHERE
		) ELSE SET "PYTHON_BAT=%QGIS_FOLDER%\python-qgis-ltr.bat"
) ELSE SET "PYTHON_BAT=%QGIS_FOLDER%\python-qgis.bat"

SET "QGIS3_PATH=%userprofile%\AppData\Roaming\QGIS\QGIS3\profiles\default\python"

IF NOT EXIST "%QGIS3_PATH%" (
	START CMD /C "ECHO The QGIS3 user folder doesn't exist. && PAUSE"
	GOTO EXITHERE
)

SET "QGIS_PLUGIN_PATH=%QGIS3_PATH%\plugins"

IF NOT EXIST "%QGIS_PLUGIN_PATH%" (
	MKDIR %QGIS_PLUGIN_PATH%
	ECHO QGIS plugin folder created. 
)

CALL "%PYTHON_BAT%" -m pip --version

IF ERRORLEVEL 1 (	
	CALL "%PYTHON_BAT%" -m easy_install -U pip
)

CALL "%PYTHON_BAT%" -c "import setuptools"
CALL "%PYTHON_BAT%" -m pip install pyserial
CALL "%PYTHON_BAT%" -m pip install pybluez
ECHO The required packages have been successfully installed.


IF ERRORLEVEL 1 (
	START CMD /C "ECHO The required packages have not been installed correctly. Please contact the MesoHABSIM development team (eflows@isprambiente.it). && PAUSE"
	GOTO EXITHERE
)

IF EXIST %QGIS_PLUGIN_PATH%\mapstream (
	RD /S /Q %QGIS_PLUGIN_PATH%\mapstream
)

XCOPY /E /Y "%~dp0\mapstream" "%QGIS_PLUGIN_PATH%\mapstream\"

START CMD /C "ECHO The MapStream QGIS plugin has been installed correctly. && PAUSE"

REM EXIT